diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -13860,6 +14383,11 @@
 		/* check against LIKE_EPSILON (values close to zero are problematic) */
 		if (like < LIKE_EPSILON)
 			{
+#if defined(ALTSCALING)
+			  had_like_epsilon = 1;
+			  if (! did_scaling)
+			    return ERROR;
+#endif
 			MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 			return ERROR;
 			}
@@ -13893,7 +14421,8 @@
 	int				b, c, j, k, nBetaCats, nGammaCats, nStates;
 	MrBFlt			catLike, catFreq, gammaFreq, like, *bs, *bsBase,
 					pUnobserved, pObserved;
-	CLFlt			*clP, *lnScaler, *nSitesOfPat;
+	CLFlt			*clP, *lnScaler;
+	CLFlt2                  *nSitesOfPat;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -13957,6 +14486,11 @@
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
 			if (like < LIKE_EPSILON)
 				{
+#if defined(ALTSCALING)
+				  had_like_epsilon = 1;
+				  if (! did_scaling)
+				    return ERROR;
+#endif
 				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 				return ERROR;
 				}
@@ -14033,6 +14567,11 @@
 			/* check against LIKE_EPSILON (values close to zero are problematic) */
 			if (like < LIKE_EPSILON)
 				{
+#if defined(ALTSCALING)
+				  had_like_epsilon = 1;
+				  if (! did_scaling)
+				    return ERROR;
+#endif
 				MrBayesPrint ("%s   WARNING: In LIKE_EPSILON - for division %d char %d has like = %1.30lf\n", spacer, division, c, like);
 				return ERROR;
 				}
@@ -14087,7 +14626,8 @@
 	int				c, i, nStates;
 	long			done, *pL, *pR, *pP, *pA, *oldpP, x;
 	CLFlt			nParsChars, treeLength;
-	CLFlt			length, *nSitesOfPat, *newNodeLength, oldNodeLength;
+	CLFlt			length, *newNodeLength, oldNodeLength;
+	CLFlt2                  *nSitesOfPat;
 	Tree			*t;
 	ModelInfo		*m;
 
@@ -14268,7 +14808,7 @@
 	int				c, i, *nStates;
 	long			*pL, *pR, *pP, *pA, *oldpP, x;
 	CLFlt			*treeLength;
-	CLFlt			*nSitesOfPat;
+	CLFlt2			*nSitesOfPat;
 	Tree			*t;
 	ModelInfo		*m;
 
@@ -14389,8 +14930,11 @@
 			{
 			tree = GetTree(m->brlens, chain, state[chain]);
 
-			if (m->parsModelId == NO)
-				{
+			if (m->parsModelId == NO) {
+#if defined(ALTSCALING)
+			  had_like_epsilon = 0;
+			  did_scaling = 0;
+#endif
 				for (i=0; i<tree->nIntNodes; i++)
 					{
 					p = tree->intDownPass[i];
@@ -14432,8 +14976,13 @@
 							m->CondLikeDown (p, d, chain);
 
 #						if !defined (DEBUG_NOSCALING)
+#if defined(ALTSCALING)
+						if (Bit(d,&p->scalersSet[0]) == 1)
+						  m->CondLikeScaler (p, d, chain, 0);
+#else
 						if (p->scalerNode == YES || Bit(d,&p->scalersSet[0]) == 1)
-							m->CondLikeScaler (p, d, chain);
+						  m->CondLikeScaler (p, d, chain, 1);
+#endif
 #						endif
 						}
 					}
@@ -14441,6 +14990,30 @@
 				
 			lnL = 0.0;
 			m->Likelihood (tree->root->left, d, chain, &lnL, (chainId[chain] % chainParams.numChains));
+#if defined(ALTSCALING)
+			if ((m->parsModelId == NO) && had_like_epsilon) {
+			  had_like_epsilon = 0; /* reset */
+			  for (i=0; i<tree->nIntNodes; i++) {
+			    p = tree->intDownPass[i];
+			    if ((p->upDateCl == YES) && (p->left != NULL)) /* suspect latter check not necc... - Allen */
+			      m->CondLikeScaler (p, d, chain, 1);
+			  }
+			  if (! did_scaling) {
+			    MrBayesPrint("%s   WARNING: For division %d (partition %d) chain %d no scaling done despite repeat\n",
+					 spacer, d, d+1, chain);
+			    did_scaling = 1; /* so that Likelihood_Gen will do the right thing */
+			  }
+			  lnL = 0.0;
+			  m->Likelihood (tree->root->left, d, chain, &lnL, (chainId[chain] % chainParams.numChains));
+			  MrBayesPrint("%s   WARNING: For division %d (partition %d) chain %d lnL is %1.30lf after scaling (chainLnLike before adding is %1.30lf)\n",
+				       spacer, d, d+1, chain, lnL, chainLnLike);
+			}
+#endif
+#ifdef DEBUG_SCALER_NAN
+			if (! (isfinite(lnL)))
+			  MrBayesPrint("%s   WARNING: For division %d (partition %d) chain %d lnL is %1.30lf (chainLnLike is %1.30lf)\n",
+				       spacer, d, d+1, chain, lnL, chainLnLike);
+#endif
 			m->lnLike[2*chain + state[chain]] =  lnL;
 			}
 		chainLnLike += m->lnLike[2*chain + state[chain]];
@@ -14568,7 +15141,7 @@
 				{
 				alphaDir = mp->revMatDir;
 				sum = 0.0;
-				for (i=0; i<6; i++)
+				for (i=0; i<6; i++) /* ASSUMES NUC? XXX - Allen */
 					sum += st[i];
 				for (i=0; i<6; i++)
 					newProp[i] = st[i] / sum;
@@ -14645,7 +15218,9 @@
 			lnPrior += log(1.0) - log(mp->corrUni[1] - mp->corrUni[0]);
 			}
 		else if (p->paramType == P_SWITCH)
-			{
+			{ /* Note that, since covswitchUni values are 0-100, the below will usually be subtracting
+			     a positive number, unlike P_PINVAR, which will be taking the log of a number below 1 -
+			     giving a negative value - and subtracting it, which will increase the lnPrior - Allen */
 			/* switching rate parameter of covarion model */
 			mp = &modelParams[p->relParts[0]];
 			if (p->paramId == SWITCH_UNI)
@@ -14656,8 +15231,12 @@
 				{
 				lnPrior += log(mp->covswitchExp) - mp->covswitchExp * st[0];
 				}
-			}
-		else if (p->paramType == P_RATEMULT)
+			else if (p->paramId == SWITCH_PINVUNI) { /* best guess! - Allen */
+			  x = mp->covswitchUni[0]/(mp->covswitchUni[0]+mp->covswitchUni[1]); /* min pinvar */
+			  lnPrior += log(1.0) - log(mp->covswitchUni[1] - mp->covswitchUni[0])
+			    - log(mp->covswitchMaxPinvar - x);
+			} /* Have decided not to try doing SWITCH_PINVEXP due to uncertainty - Allen */
+		} else if (p->paramType == P_RATEMULT)
 			{
 			
 			
@@ -14934,11 +15513,12 @@
 {
 
 	int				i, j, k, nNodes;
-	MrBFlt			*ct, tempD, lastCoalescenceTime, coalescenceTime, intervalLength;
+	MrBFlt			tempD, lastCoalescenceTime, coalescenceTime, intervalLength;
+	CLFlt2                  *ct;
 	TreeNode		*p;
 
 	/* allocate space for the coalescence times */
-	ct = (MrBFlt *)SafeMalloc((size_t) (t->nIntNodes) * sizeof(MrBFlt));
+	ct = (CLFlt2 *)SafeMalloc((size_t) (t->nIntNodes) * sizeof(CLFlt2));
 	if (!ct)
 		{
 		printf ("\n   ERROR: Problem allocating ct\n");
@@ -14950,7 +15530,7 @@
 		{
 		p = t->intDownPass[i];
 		if (p->anc != NULL)
-			ct[j++] = p->nodeDepth;
+			ct[j++] = (CLFlt2) p->nodeDepth;
 		}
 	nNodes = j;
 
@@ -15219,7 +15799,7 @@
 	/* Change correlation parameter (-1, 1) of adgamma model */
 
 	int			i, isValidP;
-	MrBFlt		oldP, newP, window, minP, maxP, ran, *markovTiValues;
+	MrBFlt		oldP, newP, window, minP, maxP, wasNewP, ran, *markovTiValues;
 	ModelParams *mp;
 
 	/* get size of window, centered on current rho */
@@ -15244,13 +15824,26 @@
 	
 	/* check that new value is valid */
 	isValidP = NO;
-	do
-		{
-		if (newP < minP)
+	do {
+	  if (newP < minP) {
+	    wasNewP = newP;
 			newP = 2* minP - newP;
-		else if (newP > maxP)
+	    if (newP > maxP) { /* avoid infinite loops - Allen */
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_Adgamma): newP %2.6lf orig %2.6lf tmp %2.6lf minP %2.6lf maxP %2.6lf window %2.6lf ran %2.6lf\n",
+                           spacer, newP, oldP, wasNewP, minP, maxP, window, ran);
+              return(NO_ERROR);
+	    }
+	  } else if (newP > maxP) {
+	    wasNewP = newP;
 			newP = 2 * maxP - newP;
-		else
+	    if (newP < minP) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_Adgamma): newP %2.6lf orig %2.6lf tmp %2.6lf minP %2.6lf maxP %2.6lf window %2.6lf ran %2.6lf\n",
+                           spacer, newP, oldP, wasNewP, minP, maxP, window, ran);
+              return(NO_ERROR);
+	    }
+	  } else
 			isValidP = YES;
 		} while (isValidP == NO);
 
@@ -16019,7 +16612,7 @@
 
 	/* change one branch length */
 
-	MrBFlt		tuning, maxV, minV, m, newM, brlensPrExp=0.0;
+	MrBFlt		tuning, maxV, minV, m, newM, tmpM, brlensPrExp=0.0;
 	TreeNode	*p;
 	ModelParams *mp;
 	Tree		*t;
@@ -16048,7 +16641,8 @@
 	do
 		{
 		p = t->allDownPass[(int)(RandomNumber(seed)*t->nNodes)];
-		} while (p->anc == NULL || (t->isRooted == YES && p->anc->anc == NULL));
+		} while (p->anc == NULL || (t->isRooted == YES && p->anc->anc == NULL) ||
+			 (p->length <= 0.0)); /* - Allen */
 
 	/* determine new length */
 	m = p->length;
@@ -16055,12 +16649,32 @@
 	newM = m * exp(tuning * (RandomNumber(seed) - 0.5));
 
 	/* reflect new length if necessary */
-	while (newM < minV || newM > maxV)
-		{
-		if (newM < minV)
+	/* Putting in below code so that will not go into an infinite loop - Allen */
+	while (newM < minV || newM > maxV) {
+	  if (newM < minV) {
+	    tmpM = newM;
 			newM = minV * minV / newM;
-		else if (newM > maxV)
+	    if (newM > maxV) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_BrLen): m %1.6lf orig newM %1.6lf newM %1.6lf minV %1.6lf maxV %1.6lf\n",
+			   spacer, m, tmpM, newM, minV, maxV);
+	      return(NO_ERROR);
+	    }
+	  } else if (newM > maxV) {
+	    tmpM = newM;
 			newM = maxV * maxV / newM;
+	    if (newM < minV) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_BrLen): m %1.6lf orig newM %1.6lf newM %1.6lf minV %1.6lf maxV %1.6lf\n",
+			   spacer, m, tmpM, newM, minV, maxV);
+	      return(NO_ERROR);
+	    }
+	  }
+	}
+	/* getting some extremely small, rather useless moves - Allen */
+	if (fabs(newM - p->length) < BRLEN_EPSILON) {
+	  abortMove = YES;
+	  return(NO_ERROR);
 		}
 	p->length = newM;
 
@@ -16697,7 +17311,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -16733,7 +17347,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -17233,7 +17847,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -17269,7 +17883,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -17731,7 +18345,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -17765,7 +18379,7 @@
 					u->isLocked = YES;
 					a->isLocked = NO;
 					u->lockID = a->lockID;
-					a->lockID = 0;
+					a->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -18572,13 +19186,27 @@
 	/* record c length and adjust with multiplier using reflection */
 	m = c->length;
 	x = c->length * exp(tuning * (RandomNumber(seed) - 0.5));		/* save the modified dangling branch for later use */
-	while (x < minV || x > maxV)
-		{
-		if (x < minV)
+	while (x < minV || x > maxV) {
+	  if (x < minV) {
+	    y = x;
 			x = minV * minV / x;
-		else if (x > maxV)
+	    if (x > maxV) {
+              abortMove = YES;
+              MrBayesPrint("%s   ERROR (Move_ExtTBR; 1): x %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+                           spacer, x, m, y, minV, maxV, tuning);
+              return(NO_ERROR);
+            }
+	  } else if (x > maxV) {
+	    y = x;
 			x = maxV * maxV / x;
+	    if (x < minV) {
+              abortMove = YES;
+              MrBayesPrint("%s   ERROR (Move_ExtTBR; 1): x %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+                           spacer, x, m, y, minV, maxV, tuning);
+              return(NO_ERROR);
+            }
 		}
+	}
 	
 	/* calculate proposal and prior ratio based on length modification */
 	(*lnProposalRatio) = log (x / m);
@@ -18588,13 +19216,27 @@
 	/* record v length and adjust with multiplier using reflection*/
 	m = v->length;
 	v->length *= exp(tuning * (RandomNumber(seed) - 0.5));
-	while (v->length < minV || v->length > maxV)
-		{
-		if (v->length < minV)
+	while (v->length < minV || v->length > maxV) {
+	  if (v->length < minV) {
+	    y = v->length;
 			v->length = minV * minV / v->length;
-		else if (v->length > maxV)
+	    if (v->length > maxV) {
+              abortMove = YES;
+              MrBayesPrint("%s   ERROR (Move_ExtTBR; 2): len %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+                           spacer, v->length, m, y, minV, maxV, tuning);
+              return(NO_ERROR);
+            }
+	  } else if (v->length > maxV) {
+	    y = v->length;
 			v->length = maxV * maxV / v->length;
+	    if (v->length < minV) {
+              abortMove = YES;
+              MrBayesPrint("%s   ERROR (Move_ExtTBR; 2): len %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+                           spacer, v->length, m, y, minV, maxV, tuning);
+              return(NO_ERROR);
 		}
+	  }
+	}
 	v->upDateTi = YES;
 
 	/* adjust proposal and prior ratio based on length modification */
@@ -18648,16 +19290,29 @@
 
 	/* adjust length of branch to be modified */
 	/* if it is not the root branch of a rooted tree */
-	if (t->isRooted == NO || u->anc->anc != NULL) 
-		{
+	if (t->isRooted == NO || u->anc->anc != NULL) {
 		m = u->length;
 		u->length *= exp(tuning * (RandomNumber(seed) - 0.5));
-		while (u->length < minV || u->length > maxV)
-			{
-			if (u->length < minV)
+	  while (u->length < minV || u->length > maxV) {
+	    if (u->length < minV) {
+	      y = u->length;
 				u->length = minV * minV / u->length;
-			else if (u->length > maxV)
+	      if (u->length > maxV) {
+		abortMove = YES;
+		MrBayesPrint("%s   ERROR (Move_ExtTBR; 3): len %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+			     spacer, u->length, m, y, minV, maxV, tuning);
+		return(NO_ERROR);
+	      }
+	    } else if (u->length > maxV) {
+	      y = u->length;
 				u->length = maxV * maxV / u->length;
+	      if (u->length < minV) {
+		abortMove = YES;
+		MrBayesPrint("%s   ERROR (Move_ExtTBR; 3): len %2.6lf orig %2.6lf tmp %2.6lf minV %2.6lf maxV %2.6lf tuning %2.6lf\n",
+			     spacer, u->length, m, y, minV, maxV, tuning);
+		return(NO_ERROR);
+	      }
+	    }
 			}
 
 		/* adjust proposal and prior ratio based on length modification */
@@ -18708,7 +19363,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -18744,7 +19399,7 @@
 					u->isLocked = YES;
 					b->isLocked = NO;
 					u->lockID = b->lockID;
-					b->lockID = 0;
+					b->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -19138,7 +19793,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -19174,7 +19829,7 @@
 					u->isLocked = YES;
 					b->isLocked = NO;
 					u->lockID = b->lockID;
-					b->lockID = 0;
+					b->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -19662,7 +20317,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -19698,7 +20353,7 @@
 					u->isLocked = YES;
 					b->isLocked = NO;
 					u->lockID = b->lockID;
-					b->lockID = 0;
+					b->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -20236,7 +20891,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -20272,7 +20927,7 @@
 					u->isLocked = YES;
 					b->isLocked = NO;
 					u->lockID = b->lockID;
-					b->lockID = 0;
+					b->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -20854,7 +21509,7 @@
 				b->isLocked = YES;
 				u->isLocked = NO;
 				b->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			}
 		else 
@@ -20890,7 +21545,7 @@
 					u->isLocked = YES;
 					b->isLocked = NO;
 					u->lockID = b->lockID;
-					b->lockID = 0;
+					b->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			}
@@ -21164,7 +21819,6 @@
 #endif
 
 	return (NO_ERROR);
-	
 }
 
 
@@ -21178,10 +21829,9 @@
 	/* change gamma shape parameter using multiplier */
 	
 	int			i, isAPriorExp, isValidA;
-	MrBFlt		oldA, newA, minA, maxA, alphaExp=0.0, ran, factor, tuning, *gammaRates;
+	MrBFlt		oldA, newA, wasNewA, minA, maxA, alphaExp=0.0, ran, factor, tuning, *gammaRates;
 	ModelParams *mp;
 
-	/* get tuning parameter */
 	tuning = mvp[0];
 
 	/* get model params */
@@ -21216,13 +21866,27 @@
 
 	/* check validity */
 	isValidA = NO;
-	do
-		{
-		if (newA < minA)
+	/* Putting in below code so that will not go into an infinite loop (have seen this) - Allen */
+	do {
+	  if (newA < minA) {
+	    wasNewA = newA;
 			newA = minA * minA / newA;
-		else if (newA > maxA)
+	    if (newA > maxA) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_GammaShape_M): newA %2.6lf orig %2.6lf tmp %2.6lf minA %2.6lf maxA %2.6lf tuning %2.6lf factor %2.6lf ran %2.6lf\n",
+                           spacer, newA, oldA, wasNewA, minA, maxA, tuning, factor, ran);
+              return(NO_ERROR);
+	    }
+	  } else if (newA > maxA) {
+	    wasNewA = newA;
 			newA = maxA * maxA / newA;
-		else
+	    if (newA < minA) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_GammaShape_M): newA %2.6lf orig %2.6lf tmp %2.6lf minA %2.6lf maxA %2.6lf tuning %2.6lf factor %2.6lf ran %2.6lf\n",
+                           spacer, newA, oldA, wasNewA, minA, maxA, tuning, factor, ran);
+              return(NO_ERROR);
+	    }
+	  } else
 			isValidA = YES;
 		} while (isValidA == NO);
 
@@ -21583,7 +22247,7 @@
 				v->isLocked = YES;
 				u->isLocked = NO;
 				v->lockID = u->lockID;
-				u->lockID = 0;
+				u->lockID = -1; /* to -1 from 0 - Allen */
 				}
 			if (v->left == d)
 				v->right = u;
@@ -22468,7 +23132,7 @@
 int Move_NodeSlider (Param *param, int chain, long *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp)
 
 {
-	MrBFlt		tuning, maxV, minV, oldM, newM, brlensPrExp=0.0, newMin, newMax, oldMin, oldMax;
+	MrBFlt		tuning, maxV, minV, oldM, newM, brlensPrExp=0.0, newMin, newMax, oldMin, oldMax, tmpM;
 	TreeNode	*p, *q;
 	ModelParams *mp;
 	Tree		*t;
@@ -22508,12 +23172,29 @@
 	/* determine new length */
 	oldM = (q->length + p->length);
 	newM = oldM * exp(tuning * (RandomNumber(seed) - 0.5));
-	while (newM < 2.0 * minV || newM > 2.0 * maxV)
-		{
-		if (newM < 2.0 * minV)
-			newM = 4.0 * minV * minV / newM;
-		else if (newM > 2.0 * maxV)
-			newM = 4.0 * maxV * maxV / newM;
+	/* Putting in below code so that will not go into an infinite loop - Allen */
+	while ((newM < (2.0*minV)) || (newM > (2.0*maxV))) {
+	  if (newM < (2.0*minV)) {
+	    tmpM = newM;
+	    newM = (4.0 * minV * minV)/newM;
+	    if (newM > (2.0*maxV)) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_NodeSlider): oldM %1.6lf (%1.6lf %1.6lf) orig newM %1.6lf newM %1.6lf 2*minV %1.6lf 2*maxV %1.6lf\n",
+			   spacer, oldM, q->length, p->length, tmpM, newM, (2.0*minV),
+			   (2.0*maxV));
+	      return(NO_ERROR);
+	    }
+	  } else if (newM > (2.0*maxV)) {
+	    tmpM = newM;
+	    newM = (4.0 * maxV * maxV)/newM;
+	    if (newM < (2.0*minV)) {
+	      abortMove = YES;
+	      MrBayesPrint("%s   ERROR (Move_NodeSlider): oldM %1.6lf (%1.6lf %1.6lf) orig newM %1.6lf newM %1.6lf 2*minV %1.6lf 2*maxV %1.6lf\n",
+			   spacer, oldM, q->length, p->length, tmpM, newM, (2.0*minV),
+			   (2.0*maxV));
+	      return(NO_ERROR);
+	    }
+	  }
 		}
 
 	/* determine new lengths of p and q */
@@ -22549,7 +23230,148 @@
 }
 
 
+/*-----------------------------------------------------------------------------------
+|
+|	Move_NodeSlider2: move the position of one node without changing topology
+|
+-------------------------------------------------------------------------------------*/
+
+int Move_NodeSlider2 (Param *param, int chain, long *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp) {
+  MrBFlt      tuning, maxV, minV, oldM, newM, brlensPrExp=0.0, newMin, newMax, oldMin, oldMax, tmpM;
+  MrBFlt      oldProp, newProp, minProp, maxProp, window, tmpProp;
+  int         isValidP;
+  TreeNode    *p, *q;
+  ModelParams *mp;
+  Tree	      *t;
+
+  tuning = mvp[0]; /* Larget & Simon's tuning parameter lambda */
+  window = mvp[1]; /* window size for proportion - Allen */
+  
+  mp = &modelParams[param->relParts[0]];
+  
+  /* max and min brlen */
+  if (param->paramId == BRLENS_UNI) {
+    minV = mp->brlensUni[0] > BRLENS_MIN ? mp->brlensUni[0] : BRLENS_MIN;
+    maxV = mp->brlensUni[1];
+  } else {
+    minV = BRLENS_MIN;
+    maxV = BRLENS_MAX;
+    brlensPrExp = mp->brlensExp;
+  }
+
+  /* get tree */
+  t = GetTree (param, chain, state[chain]);
+  
+  /* pick an interior branch */
+  do {
+    p = t->intDownPass[(int)(RandomNumber(seed)*t->nIntNodes)];
+  } while (p->anc == NULL || (t->isRooted == YES && p->anc->anc == NULL));
+
+  /* pick one descendant branch */
+  if (RandomNumber(seed) < 0.5)
+    q = p->left;
+  else
+    q = p->right;
+  
+  /* determine new length */
+  oldM = (q->length + p->length);
+  oldProp = q->length/oldM;
+  newM = oldM * exp(tuning * (RandomNumber(seed) - 0.5));
+  /* Putting in below code so that will not go into an infinite loop - Allen */
+  while ((newM < (2.0*minV)) || (newM > (2.0*maxV))) {
+    if (newM < (2.0*minV)) {
+      tmpM = newM;
+      newM = (4.0 * minV * minV)/newM;
+      if (newM > (2.0*maxV)) {
+	abortMove = YES;
+	MrBayesPrint("%s   ERROR (Move_NodeSlider2): oldM %1.6lf (%1.6lf %1.6lf) orig newM %1.6lf newM %1.6lf 2*minV %1.6lf 2*maxV %1.6lf\n",
+		     spacer, oldM, q->length, p->length, tmpM, newM, (2.0*minV),
+		     (2.0*maxV));
+	return(NO_ERROR);
+      }
+    } else if (newM > (2.0*maxV)) {
+      tmpM = newM;
+      newM = (4.0 * maxV * maxV)/newM;
+      if (newM < (2.0*minV)) {
+	abortMove = YES;
+	MrBayesPrint("%s   ERROR (Move_NodeSlider2): oldM %1.6lf (%1.6lf %1.6lf) orig newM %1.6lf newM %1.6lf 2*minV %1.6lf 2*maxV %1.6lf\n",
+		     spacer, oldM, q->length, p->length, tmpM, newM, (2.0*minV),
+		     (2.0*maxV));
+	return(NO_ERROR);
+      }
+    }
+  }
+
+  /* determine new lengths of p and q */
+  newMin = minV > newM - maxV ? minV : newM - maxV;
+  newMax = maxV < newM - minV ? maxV : newM - minV;
+  oldMin = minV > oldM - maxV ? minV : oldM - maxV;
+  oldMax = maxV > oldM - minV ? maxV : oldM - minV;
+  minProp = newMin/newM;
+  maxProp = newMax/newM;
+  
+  if ((newMax - newMin) < minV)
+    q->length = newMin + RandomNumber(seed) * (newMax - newMin);
+  else if (minProp < maxProp) {
+    /* do a sliding window - Allen */
+    newProp = oldProp + window * (RandomNumber(seed) - 0.5);
+    /* check validity */
+    isValidP = NO;
+    do {
+      if (newProp < minProp) {
+	tmpProp = newProp;
+	newProp = 2*minProp - newProp;
+	if (newProp > maxProp) {
+	  abortMove = YES;
+	  MrBayesPrint("%s   ERROR (Move_NodeSlider2): oldM %1.6lf (%1.6lf %1.6lf) newM %1.6lf oldProp %1.6lf orig newProp %1.6lf newProp %1.6lf minProp %1.6lf maxProp %1.6lf\n",
+		       spacer, oldM, q->length, p->length, newM, oldProp, tmpProp, newProp, minProp, maxProp);
+	  return(NO_ERROR);
+	}
+      } else if (newProp > maxProp) {
+	tmpProp = newProp;
+	newProp = 2*maxProp - newProp;
+	if (newProp < minProp) {
+	  abortMove = YES;
+	  MrBayesPrint("%s   ERROR (Move_NodeSlider2): oldM %1.6lf (%1.6lf %1.6lf) newM %1.6lf oldProp %1.6lf orig newProp %1.6lf newProp %1.6lf minProp %1.6lf maxProp %1.6lf\n",
+		       spacer, oldM, q->length, p->length, newM, oldProp, tmpProp, newProp, minProp, maxProp);
+	  return(NO_ERROR);
+	}
+      } else
+	isValidP = YES;
+    } while (isValidP == NO);
+
+    q->length = newM*newProp;
+    if (q->length < newMin)
+      q->length = newMin;
+    else if (q->length > newMax)
+      q->length = newMax;
+  } else /* just in case is due to roundoff error */
+    q->length = (newMin+newMax)/2;
+
+  p->length = newM - q->length;
+
+  /* set flags for update of transition probabilities at p and q */
+  p->upDateTi = YES;
+  q->upDateTi = YES;
+  p->upDateCl = YES;
+  
+  /* set flags for update of cond likes from p->anc and down to root */
+  while (p->anc != NULL)
+    {
+      p = p->anc;
+      p->upDateCl = YES;
+    }
+  
+  /* calculate proposal ratio */
+  (*lnProposalRatio) = log(newM / oldM) + log ((newMax - newMin) / (oldMax - oldMin));
+  
+  /* update prior if exponential prior on branch lengths */
+  if (param->paramId == BRLENS_EXP)
+    (*lnPriorRatio) = brlensPrExp * (oldM - newM);
+  
+  return (NO_ERROR);
 
+}
 
 
 /*-----------------------------------------------------------------------------------
@@ -24173,7 +24995,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -24220,7 +25042,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -24753,7 +25575,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -24800,7 +25622,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -25362,7 +26184,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -25409,7 +26231,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -26043,7 +26865,7 @@
 					b->isLocked = YES;
 					u->isLocked = NO;
 					b->lockID = u->lockID;
-					u->lockID = 0;
+					u->lockID = -1; /* to -1 from 0 - Allen */
 					}
 				}
 			else 
@@ -26090,7 +26912,7 @@
 						u->isLocked = YES;
 						b->isLocked = NO;
 						u->lockID = b->lockID;
-						b->lockID = 0;
+						b->lockID = -1; /* to -1 from 0 - Allen */
 						}
 					}
 				}
@@ -27480,16 +28302,16 @@
 
 	/* change pi */
 	int			i, nStates;
-	MrBFlt		dirichletParameters[64], *newPi, *oldPi, symDirAlphai, sum, alphaPi, x, y;
+	MrBFlt		dirichletParameters[64], *newPi, *oldPi, *origDirAlpha, sum, alphaPi, x, y;
 
 	/* get the values we need */
 	nStates = param->nSubValues;
-	symDirAlphai = *GetParamVals(param, chain, state[chain]);
+	origDirAlpha = GetParamVals(param, chain, state[chain]);
 	newPi = GetParamSubVals (param, chain, state[chain]);
 	oldPi = GetParamSubVals (param, chain, state[chain] ^ 1);
 	
 #	if defined ASYMMETRY
-	nStates /= 2;
+	nStates /= 2; /* Shouldn't this be only for the RESTRICTION datatype? - Allen */
 	if (RandomNumber (seed) < 0.5)
 		{
 		newPi += 2;
@@ -27499,9 +28321,18 @@
 	
 	alphaPi = mvp[0];
 
-	/* multiply old values with some large number to get new values close to the old ones */
+	sum = 0.0;
 	for (i=0; i<nStates; i++)
+		sum += origDirAlpha[i];
+	sum /= nStates; /* so for default of equal to # of states will be 1 - Allen */
+
+	/* multiply old values with some large number to get new values close to the old ones */
+	for (i=0; i<nStates; i++) {
+		if ((sum != 1) && (AreDoublesEqual(oldPi[i],(origDirAlpha[i]/(sum*nStates)),0.0001) != NO))
+			dirichletParameters[i] = oldPi[i] * alphaPi * sum;
+		else
 		dirichletParameters[i] = oldPi[i] * alphaPi;
+	}
 
 	DirichletRandomVariable (dirichletParameters, newPi, nStates, seed);
 
@@ -27522,24 +28353,46 @@
 	x = LnGamma(sum);
 	for (i=0; i<nStates; i++)
 		x -= LnGamma(newPi[i]*alphaPi);
-	for (i=0; i<nStates; i++)
+	for (i=0; i<nStates; i++) {
+		if (oldPi[i] >= 0.0001) /* Allen */
 		x += (newPi[i]*alphaPi-1.0)*log(oldPi[i]);
+		else
+			x += (newPi[i]*alphaPi-1.0)*log(0.0001);
+	}
 	sum = 0.0;
-	for (i=0; i<nStates; i++)
+	for (i=0; i<nStates; i++) {
+		if (oldPi[i] >= 0.0001)
 		sum += oldPi[i]*alphaPi;
+		else
+			sum += 0.0001*alphaPi;
+	}
 	y = LnGamma(sum);
-	for (i=0; i<nStates; i++)
+	for (i=0; i<nStates; i++) {
+		if (oldPi[i] >= 0.0001) {
 		y -= LnGamma(oldPi[i]*alphaPi);
-	for (i=0; i<nStates; i++)
 		y += (oldPi[i]*alphaPi-1.0)*log(newPi[i]);
+		} else {
+			y -= LnGamma(0.0001*alphaPi);
+			y += (0.0001*alphaPi-1.0)*log(newPi[i]);
+		}
+	}
 	(*lnProposalRatio) = x - y;
 
-	/* get prior ratio */
-	y = x = 0.0;					/* the Gamma part of the prior is the same */
+	/* get prior ratio */ /* The below is my best guess of how it was supposed to be done; it appears
+			         that the old version was copied from Move_StatefreqsSymDirMultistate
+				 and not changed properly; should really try to figure out how to
+				 get it to matter more depending on origDirAlpha! XXX - Allen */
+	y = x = sum = 0.0;				/* the Gamma part of the prior is the same */
 	for (i=0; i<nStates; i++)
-		x += (symDirAlphai-1.0)*log(newPi[i]);
+		sum += origDirAlpha[i];
 	for (i=0; i<nStates; i++)
-		y += (symDirAlphai-1.0)*log(oldPi[i]);
+		x += ((origDirAlpha[i]/sum)-1)*log(newPi[i]);
+	for (i=0; i<nStates; i++) {
+		if (oldPi[i] >= 0.0001)
+			y += ((origDirAlpha[i]/sum)-1)*log(oldPi[i]);
+		else
+			y += ((origDirAlpha[i]/sum)-1)*log(0.0001);
+	}
 	(*lnPriorRatio) = x - y;
 		
 	for (i=0; i<param->nRelParts; i++)
@@ -27660,7 +28513,7 @@
 	/* change switch rate of covarion model using sliding window */
 	
 	int			i, isSPriorExp, isValidS, whichRate;
-	MrBFlt		oldS, newS, window, minS, maxS, sExp=0.0, ran, *value;
+	MrBFlt		oldS, newS, window, minS, maxS, sExp=0.0, ran, *value, tmpS;
 	ModelParams *mp;
 
 	/* decide which switching rate to change */
